/**
 * TicketMachine models a naive ticket machine that issues
 * flat-fare tickets.
 * The price of a ticket is specified via the constructor.
 * It is a naive machine in the sense that it trusts its users
 * to insert enough money before trying to print a ticket.
 * It also assumes that users enter sensible amounts.
 *
 * @author David J. Barnes and Michael Kolling
 * @version 2008.03.30
 */
public class TicketMachine
{
    // The price of a ticket from this machine.
    private int price;
    // The amount of money entered by a customer so far.
    private int balance;
    // The total amount of money collected by this machine.
    private int total;
    // The Status 
    private int status;
    
    private int score = 100;
    
    private int discount = 20;
    
    private int saving;
    
    

    /**
     * Create a machine that issues tickets of the given price.
     * Note that the price must be greater than zero, and there
     * are no checks to ensure this.
     */
    
    public TicketMachine()
    {
      int price = 1000;
      balance = 0;
      total = 0;
    } 

    /*public TicketMachine(int ticketCost)
    {
        price = ticketCost;
        balance = 0;
        total = 0;
    }*/

    /**
     * Return the price of a ticket.
     */
    public int getPrice()
    {
        return price;
    }

    /**
     * Return the amount of money already inserted for the
     * next ticket.
     */
    public int getAmount()
    {
        return balance;
    }

    /**
     * Receive an amount of money in cents from a customer.
     */
    public void insertMoney(int amount)
    {
        balance = balance + amount;
    }
    
    public int getTotal() {
        return total;
    }
    
    /**
    * Increase score by the given number of points.
    */
    public void increase(int points)
    {
        score += points;
    }
    
    /**
    * Reduce price by the given amount.
    */
    public void discount(int amount)
    {
        price -= amount;
    }
    // Prompt method
    public void prompt() 
    {
    System.out.println("Please insert the correct amount of money.");
    }
    // Show price method
    public void showPrice() 
    {
    System.out.println("The price of a ticket is " + price + " cents.");
    }
    // Empty method
    public void empty()
    {
        total = 0;
    }
    // Set Price method
    public int setPrice(int newPrice) 
    {
        return newPrice;
    }
    
    public void savings()
    {
        saving = price * discount;
    }
    
    public int emptyMachine() {
        return total;
        
        
        
    }

    /**
     * Print a ticket.
     * Update the total collected and
     * reduce the balance to zero.
     */
    public void printTicket()
    {
        int amountLeftToPay = price - balance;
        
        // Simulate the printing of a ticket.
        System.out.println("##################");
        System.out.println("# The BlueJ Line");
        System.out.println("# Ticket");
        System.out.println("# " + price + " cents.");
        System.out.println("##################");
        System.out.println();

        // Update the total collected with the balance.
        total = total + balance;
        // Clear the balance.
        balance = 0;
    }
}
